# -*- coding: utf-8 -*-
from setuphelpers import *
import sys
import time
import os
import glob

"""     
    "update_package_dependencies": [
        "tis-wapt-selenium",
        "tis-chrome"
    ]
"""


def update_package():
    # Importing Selenium with tis-wapt-selenium package
    sys.path.insert(0, makepath(WAPT.wapt_base_dir, "selenium"))
    from selenium import webdriver
    from selenium.webdriver.chrome.options import Options
    from selenium.webdriver.common.by import By
    from selenium.webdriver.chrome.service import Service

    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://pcmanager-en.microsoft.com/"
    download_dict = {
        "windows-x64": "MSPCManagerSetup.exe",
    }
    latest_bin = download_dict[control.target_os + "-" + ensure_list(control.architecture)[0]]

    # Deleting binaries
    for f in glob.glob("*.exe") + glob.glob("*.msi"):
        print("Removing: %s" % f)
        remove_file(f)

    chrome_options = Options()
    # chrome_options.add_argument("--headless") # security limitations with headless flag
    chrome_options.add_argument("--lang=en-us")
    chrome_options.add_argument("--disable-notifications")
    chrome_options.add_argument("--safebrowsing-disable-download-protection")
    chrome_options.add_experimental_option(
        "prefs",
        {
            "download.default_directory": f"{basedir}",
            "download.prompt_for_download": False,
            "download.directory_upgrade": True,
            "safebrowsing_for_trusted_sources_enabled": False,
            "safebrowsing.enabled": True,
        },
    )

    # Downloading with selenium
    driver = webdriver.Chrome(options=chrome_options, service=Service(makepath(WAPT.wapt_base_dir, "selenium", "chromedriver.exe")))
    driver.get(url)
    driver.find_element(By.XPATH, "/html/body/div[2]/div/main/div[1]/div/div/div/div/div/div/div[1]/div/button").click()
    wait_download()
    driver.quit()

    # Checking version from file
    version = get_version_from_binary(latest_bin)

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated


def wait_download(delay=360):
    loop = 0
    while not glob.glob("*.exe"):
        loop += 3
        if loop > delay:
            break
        time.sleep(3)
